#include <DatSubsystems/DatStatus.h>
#include <DatFile.h>

namespace LOTRO_DAT {
    void DatStatus::UpdatePercentage(unsigned percent) {
        percentage = std::min(100u, percent);
    }

    unsigned DatStatus::GetPercentage() {
        return percentage;
    }

    void DatStatus::UpdateStatusText(const std::string &message) {
        status_text = message;
    }

    void DatStatus::RemoveStatusText() {
        status_text = "none";
    }

    std::string DatStatus::GetStatusText() {
        return status_text == "none" ? "Свободен" : status_text;
    }

    bool DatStatus::CheckIfNotPatched() {
        return dat->GetLocaleManager().patch_dict_.empty();
    }

    DatStatus::DatStatus(DatFile *datFilePtr) : dat(datFilePtr), percentage(0), status_text("none") {
    }

    void DatStatus::UpdateAdditionalMessage(const std::string &message) {
        additional_message = message;
    }

    void DatStatus::RemoveAdditionalMessage() {
        additional_message = "none";
    }

    std::string DatStatus::GetAdditionalMessage() {
        return additional_message == "none" ? "" : additional_message;
    }

    void DatStatus::ClearAll() {
        RemoveAdditionalMessage();
        RemoveStatusText();
        UpdatePercentage(0);
    }
}